var SourceMessageTooltip = {
	offsetx : 0,
	offsety :  0,
	shiftkeyDown : false,
	ctrlkeyDown : false,
	mouseOverEvent : null,
	translations : {},
	html_tooltip : '\
		<div class="SourceMessageTooltip" style="left:{offsetx}px;top:{offsety}px;"><div class="SourceMessageTooltip_search"><span>Search source translation for:</span> {text}</div>{tips}</div> \
	',
		
	start : function ()
	{
		jQuery(document).keydown(function(event){
			var keycode = (event.keyCode ? event.keyCode : event.which);
			if(keycode == 16)
				SourceMessageTooltip.shiftkeyDown = true;
			
			if(keycode == 17)
				SourceMessageTooltip.ctrlkeyDown = true;
			
			// launch translation tooltip CTRL+SHIFT
			if(SourceMessageTooltip.shiftkeyDown == true && SourceMessageTooltip.ctrlkeyDown == true)
			{
				// don't run if there is already a tooltip displayed
				if(jQuery('.SourceMessageTooltip').length > 0)
					return true;
				var text = "";
			    if (window.getSelection) {
			        text = window.getSelection().toString();
			    } else if (document.selection && document.selection.type != "Control") {
			        text = document.selection.createRange().text;
			    }

			    if(text == '')
			    {
			    	if(SourceMessageTooltip.mouseOverEvent.srcElement)
			    	{
			    		text = jQuery(SourceMessageTooltip.mouseOverEvent.srcElement).html();
			    		SourceMessageTooltip.SelectText(SourceMessageTooltip.mouseOverEvent.srcElement);
			    	}
			    	else if(SourceMessageTooltip.mouseOverEvent.target)
			    	{
			    		text = jQuery(SourceMessageTooltip.mouseOverEvent.target).html();
			    		SourceMessageTooltip.SelectText(SourceMessageTooltip.mouseOverEvent.target);
			    	}
			    }
			    SourceMessageTooltip.offsetx	= SourceMessageTooltip.mouseOverEvent.pageX;
			    SourceMessageTooltip.offsety	= SourceMessageTooltip.mouseOverEvent.pageY;
			    
			    text = text.replace(/[\s\r\n]+$/, '');
			    SourceMessageTooltip.lookup(text);
			}
		});
		
		jQuery(document).keyup(function(event){
			var keycode = (event.keyCode ? event.keyCode : event.which);
			if(keycode == 16)
				SourceMessageTooltip.shiftkeyDown = false;
			if(keycode == 17)
				SourceMessageTooltip.ctrlkeyDown = false;			
		});
		
		jQuery(document).mouseover(function(event) {
			SourceMessageTooltip.mouseOverEvent = event;		
		});	

	},
	
	lookup : function(text)
	{
		if(text == '')
			return true;
		
		var tips = [];
		var found = false;
		jQuery.each( SourceMessageTooltip.translations, function(translated, original)
		{
			if(translated.indexOf(text) >=0)
			{
				tips[translated] = original;
				found = true;
			}
		});
		
		SourceMessageTooltip.tooltip(text, tips, found);		
	},
	
	tooltip: function(text, tips, found)
	{
		var html = SourceMessageTooltip.html_tooltip;
		
		html = html.replace('{text}', text);
		var tooltips	= '';
		
		for (var translated in tips)
		{
			tooltips += '<div class="SourceMessageTooltip_translated"><span>Possible match : </span>'+translated+'</div>';
			tooltips += '<div class="SourceMessageTooltip_category"><span>Category: </span>'+tips[translated].category+'</div><div class="SourceMessageTooltip_message"><span>Source Message: </span>'+tips[translated].message+'</div>';			
		}

		if(found == false)
			tooltips = 'none found';	

		html = html.replace('{tips}', tooltips);
		html = html.replace('{offsetx}',SourceMessageTooltip.offsetx);
		html = html.replace('{offsety}',SourceMessageTooltip.offsety);

		jQuery('.SourceMessageTooltip').remove();
		jQuery(html).appendTo('body');		
		
		jQuery(document).bind('click', function() {
			jQuery('.SourceMessageTooltip').remove();
		});		
	},
	
	SelectText : function(element) 
	{
	    var doc = document;
	    var text = element;    

	    if (doc.body.createTextRange) { // ms
	        var range = doc.body.createTextRange();
	        range.moveToElementText(text);
	        range.select();
	    } else if (window.getSelection) { // moz, opera, webkit
	        var selection = window.getSelection();            
	        var range = doc.createRange();
	        range.selectNodeContents(text);
	        selection.removeAllRanges();
	        selection.addRange(range);
	    }

	}
	
}

jQuery(document).ready(function() {
	SourceMessageTooltip.start();
});